Bisect visualize: use "for-each-ref" to list all good refs.
[git/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
6ca8b977 3USAGE='[start|bad|good|skip|next|reset|visualize|replay|log|run]'
38a47fd6
CC
4LONG_USAGE='git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
5 reset bisect state and start bisection.
6git bisect bad [<rev>]
7 mark <rev> a known-bad revision.
8git bisect good [<rev>...]
9 mark <rev>... known-good revisions.
6ca8b977
CC
10git bisect skip [<rev>...]
11 mark <rev>... untestable revisions.
38a47fd6
CC
12git bisect next
13 find next bisection to test and check it out.
14git bisect reset [<branch>]
15 finish bisection search and go back to branch.
16git bisect visualize
17 show bisect status in gitk.
18git bisect replay <logfile>
19 replay bisection log.
20git bisect log
21 show bisect log.
22git bisect run <cmd>...
23 use <cmd>... to automatically bisect.'
d025524d 24
ae2b0f15 25. git-sh-setup
4c550686 26require_work_tree
8cc6a083 27
e9a45d75 28sq() {
d9bffc08 29 @@PERL@@ -e '
e9a45d75
JH
30 for (@ARGV) {
31 s/'\''/'\'\\\\\'\''/g;
32 print " '\''$_'\''";
33 }
34 print "\n";
35 ' "$@"
36}
37
8cc6a083
LT
38bisect_autostart() {
39 test -d "$GIT_DIR/refs/bisect" || {
40 echo >&2 'You need to start by "git bisect start"'
41 if test -t 0
42 then
43 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
44 read yesno
45 case "$yesno" in
46 [Nn]*)
47 exit ;;
48 esac
49 bisect_start
50 else
51 exit 1
52 fi
53 }
54}
55
56bisect_start() {
8cc6a083
LT
57 #
58 # Verify HEAD. If we were bisecting before this, reset to the
59 # top-of-line master first!
60 #
5be60078 61 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref HEAD) ||
8098a178 62 die "Bad HEAD - I need a symbolic ref"
8cc6a083 63 case "$head" in
673e5838 64 refs/heads/bisect)
810255fd
PB
65 if [ -s "$GIT_DIR/head-name" ]; then
66 branch=`cat "$GIT_DIR/head-name"`
67 else
68 branch=master
8fe26f44 69 fi
810255fd 70 git checkout $branch || exit
8cc6a083
LT
71 ;;
72 refs/heads/*)
810255fd 73 [ -s "$GIT_DIR/head-name" ] && die "won't bisect on seeked tree"
e23cb8c0 74 echo "${head#refs/heads/}" >"$GIT_DIR/head-name"
8cc6a083
LT
75 ;;
76 *)
8098a178 77 die "Bad HEAD - strange symbolic ref"
8cc6a083
LT
78 ;;
79 esac
80
81 #
82 # Get rid of any old bisect state
83 #
38a47fd6 84 bisect_clean_state
8cc6a083 85 mkdir "$GIT_DIR/refs/bisect"
38a47fd6
CC
86
87 #
88 # Check for one bad and then some good revisions.
89 #
90 has_double_dash=0
91 for arg; do
92 case "$arg" in --) has_double_dash=1; break ;; esac
93 done
94 orig_args=$(sq "$@")
95 bad_seen=0
96 while [ $# -gt 0 ]; do
97 arg="$1"
98 case "$arg" in
99 --)
8fe26f44 100 shift
38a47fd6
CC
101 break
102 ;;
103 *)
8fe26f44 104 rev=$(git rev-parse --verify "$arg^{commit}" 2>/dev/null) || {
38a47fd6
CC
105 test $has_double_dash -eq 1 &&
106 die "'$arg' does not appear to be a valid revision"
107 break
108 }
737c74ee
CC
109 case $bad_seen in
110 0) state='bad' ; bad_seen=1 ;;
111 *) state='good' ;;
112 esac
113 bisect_write "$state" "$rev" 'nolog'
8fe26f44 114 shift
38a47fd6
CC
115 ;;
116 esac
8fe26f44 117 done
38a47fd6
CC
118
119 sq "$@" >"$GIT_DIR/BISECT_NAMES"
b8652b4d 120 echo "git-bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG"
38a47fd6 121 bisect_auto_next
8cc6a083
LT
122}
123
55624f9a
CC
124bisect_write() {
125 state="$1"
126 rev="$2"
737c74ee 127 nolog="$3"
55624f9a
CC
128 case "$state" in
129 bad) tag="$state" ;;
130 good|skip) tag="$state"-"$rev" ;;
131 *) die "Bad bisect_write argument: $state" ;;
132 esac
3d7cd64c 133 git update-ref "refs/bisect/$tag" "$rev"
55624f9a 134 echo "# $state: "$(git show-branch $rev) >>"$GIT_DIR/BISECT_LOG"
737c74ee 135 test -z "$nolog" && echo "git-bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
55624f9a
CC
136}
137
155fc795 138bisect_state() {
8cc6a083 139 bisect_autostart
155fc795
CC
140 state=$1
141 case "$#,$state" in
142 0,*)
143 die "Please call 'bisect_state' with at least one argument." ;;
144 1,bad|1,good|1,skip)
145 rev=$(git rev-parse --verify HEAD) ||
146 die "Bad rev input: HEAD"
147 bisect_write "$state" "$rev" ;;
148 2,bad)
149 rev=$(git rev-parse --verify "$2^{commit}") ||
150 die "Bad rev input: $2"
151 bisect_write "$state" "$rev" ;;
152 *,good|*,skip)
153 shift
154 revs=$(git rev-parse --revs-only --no-flags "$@") &&
155 test '' != "$revs" || die "Bad rev input: $@"
156 for rev in $revs
157 do
158 rev=$(git rev-parse --verify "$rev^{commit}") ||
159 die "Bad rev commit: $rev^{commit}"
160 bisect_write "$state" "$rev"
161 done ;;
cc9f24d0
JH
162 *)
163 usage ;;
8cc6a083 164 esac
97e1c51e
CC
165 bisect_auto_next
166}
167
8cc6a083 168bisect_next_check() {
0a5280a9
JH
169 missing_good= missing_bad=
170 git show-ref -q --verify refs/bisect/bad || missing_bad=t
171 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
6fecf191 172
0a5280a9
JH
173 case "$missing_good,$missing_bad,$1" in
174 ,,*)
175 : have both good and bad - ok
176 ;;
177 *,)
178 # do not have both but not asked to fail - just report.
179 false
180 ;;
181 t,,good)
182 # have bad but not good. we could bisect although
183 # this is less optimum.
184 echo >&2 'Warning: bisecting only with a bad commit.'
185 if test -t 0
186 then
187 printf >&2 'Are you sure [Y/n]? '
188 case "$(read yesno)" in [Nn]*) exit 1 ;; esac
189 fi
190 : bisect without good...
191 ;;
8cc6a083 192 *)
0a5280a9
JH
193 THEN=''
194 test -d "$GIT_DIR/refs/bisect" || {
195 echo >&2 'You need to start by "git bisect start".'
196 THEN='then '
197 }
198 echo >&2 'You '$THEN'need to give me at least one good' \
199 'and one bad revisions.'
200 echo >&2 '(You can use "git bisect bad" and' \
201 '"git bisect good" for that.)'
202 exit 1 ;;
8cc6a083
LT
203 esac
204}
205
206bisect_auto_next() {
434d036f 207 bisect_next_check && bisect_next || :
8cc6a083
LT
208}
209
97e1c51e
CC
210filter_skipped() {
211 _eval="$1"
212 _skip="$2"
213
214 if [ -z "$_skip" ]; then
215 eval $_eval
216 return
217 fi
218
219 # Let's parse the output of:
220 # "git rev-list --bisect-vars --bisect-all ..."
221 eval $_eval | while read hash line
222 do
223 case "$VARS,$FOUND,$TRIED,$hash" in
224 # We display some vars.
225 1,*,*,*) echo "$hash $line" ;;
226
227 # Split line.
228 ,*,*,---*) ;;
229
230 # We had nothing to search.
231 ,,,bisect_rev*)
232 echo "bisect_rev="
233 VARS=1
234 ;;
235
236 # We did not find a good bisect rev.
237 # This should happen only if the "bad"
238 # commit is also a "skip" commit.
239 ,,*,bisect_rev*)
240 echo "bisect_rev=$TRIED"
241 VARS=1
242 ;;
243
244 # We are searching.
245 ,,*,*)
246 TRIED="${TRIED:+$TRIED|}$hash"
247 case "$_skip" in
248 *$hash*) ;;
249 *)
250 echo "bisect_rev=$hash"
251 echo "bisect_tried=\"$TRIED\""
252 FOUND=1
253 ;;
254 esac
255 ;;
256
257 # We have already found a rev to be tested.
258 ,1,*,bisect_rev*) VARS=1 ;;
259 ,1,*,*) ;;
260
261 # ???
262 *) die "filter_skipped error " \
263 "VARS: '$VARS' " \
264 "FOUND: '$FOUND' " \
265 "TRIED: '$TRIED' " \
266 "hash: '$hash' " \
267 "line: '$line'"
268 ;;
269 esac
270 done
271}
272
273exit_if_skipped_commits () {
274 _tried=$1
275 if expr "$_tried" : ".*[|].*" > /dev/null ; then
276 echo "There are only 'skip'ped commit left to test."
277 echo "The first bad commit could be any of:"
e23cb8c0 278 echo "$_tried" | tr '[|]' '[\012]'
97e1c51e
CC
279 echo "We cannot bisect more!"
280 exit 2
281 fi
282}
283
8cc6a083 284bisect_next() {
8fe26f44 285 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 286 bisect_autostart
0a5280a9
JH
287 bisect_next_check good
288
97e1c51e
CC
289 skip=$(git for-each-ref --format='%(objectname)' \
290 "refs/bisect/skip-*" | tr '[\012]' ' ') || exit
291
292 BISECT_OPT=''
293 test -n "$skip" && BISECT_OPT='--bisect-all'
294
5be60078 295 bad=$(git rev-parse --verify refs/bisect/bad) &&
0a5280a9
JH
296 good=$(git for-each-ref --format='^%(objectname)' \
297 "refs/bisect/good-*" | tr '[\012]' ' ') &&
97e1c51e 298 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
0a5280a9 299 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
97e1c51e 300 eval=$(filter_skipped "$eval" "$skip") &&
0a5280a9
JH
301 eval "$eval" || exit
302
303 if [ -z "$bisect_rev" ]; then
304 echo "$bad was both good and bad"
305 exit 1
670f5fe3 306 fi
0a5280a9 307 if [ "$bisect_rev" = "$bad" ]; then
97e1c51e 308 exit_if_skipped_commits "$bisect_tried"
0a5280a9 309 echo "$bisect_rev is first bad commit"
5be60078 310 git diff-tree --pretty $bisect_rev
0a5280a9 311 exit 0
8cc6a083 312 fi
0a5280a9 313
97e1c51e
CC
314 # We should exit here only if the "bad"
315 # commit is also a "skip" commit (see above).
316 exit_if_skipped_commits "$bisect_rev"
317
0a5280a9 318 echo "Bisecting: $bisect_nr revisions left to test after this"
0bee49c6 319 git branch -f new-bisect "$bisect_rev"
08f16750 320 git checkout -q new-bisect || exit
0bee49c6 321 git branch -M new-bisect bisect
5be60078 322 git show-branch "$bisect_rev"
8cc6a083
LT
323}
324
cc9f24d0
JH
325bisect_visualize() {
326 bisect_next_check fail
e3f062bf
CC
327 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
328 eval gitk refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
329}
330
8cc6a083
LT
331bisect_reset() {
332 case "$#" in
810255fd
PB
333 0) if [ -s "$GIT_DIR/head-name" ]; then
334 branch=`cat "$GIT_DIR/head-name"`
335 else
336 branch=master
337 fi ;;
737c74ee
CC
338 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
339 die "$1 does not seem to be a valid branch"
8cc6a083 340 branch="$1" ;;
8fe26f44 341 *)
8cc6a083
LT
342 usage ;;
343 esac
9b709e47 344 if git checkout "$branch"; then
38a47fd6
CC
345 rm -f "$GIT_DIR/head-name"
346 bisect_clean_state
9b709e47 347 fi
e204de28
JH
348}
349
38a47fd6
CC
350bisect_clean_state() {
351 rm -fr "$GIT_DIR/refs/bisect"
947a604b
CC
352
353 # There may be some refs packed during bisection.
354 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* refs/heads/bisect |
355 while read ref hash
356 do
357 git update-ref -d $ref $hash
358 done
38a47fd6
CC
359 rm -f "$GIT_DIR/BISECT_LOG"
360 rm -f "$GIT_DIR/BISECT_NAMES"
361 rm -f "$GIT_DIR/BISECT_RUN"
362}
363
e204de28 364bisect_replay () {
737c74ee 365 test -r "$1" || die "cannot read $1 for replaying"
e204de28
JH
366 bisect_reset
367 while read bisect command rev
368 do
369 test "$bisect" = "git-bisect" || continue
370 case "$command" in
371 start)
e9a45d75 372 cmd="bisect_start $rev"
737c74ee
CC
373 eval "$cmd" ;;
374 good|bad|skip)
375 bisect_write "$command" "$rev" ;;
e204de28 376 *)
737c74ee 377 die "?? what are you talking about?" ;;
e204de28
JH
378 esac
379 done <"$1"
380 bisect_auto_next
8cc6a083
LT
381}
382
a17c4101 383bisect_run () {
83020120
CC
384 bisect_next_check fail
385
a17c4101
CC
386 while true
387 do
388 echo "running $@"
389 "$@"
390 res=$?
391
392 # Check for really bad run error.
393 if [ $res -lt 0 -o $res -ge 128 ]; then
394 echo >&2 "bisect run failed:"
395 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
396 exit $res
397 fi
398
155fc795 399 # Find current state depending on run success or failure.
71b0251c
CC
400 # A special exit code of 125 means cannot test.
401 if [ $res -eq 125 ]; then
402 state='skip'
403 elif [ $res -gt 0 ]; then
155fc795 404 state='bad'
a17c4101 405 else
155fc795 406 state='good'
a17c4101
CC
407 fi
408
155fc795
CC
409 # We have to use a subshell because "bisect_state" can exit.
410 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
a17c4101
CC
411 res=$?
412
413 cat "$GIT_DIR/BISECT_RUN"
414
71b0251c
CC
415 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
416 > /dev/null; then
417 echo >&2 "bisect run cannot continue any more"
418 exit $res
419 fi
420
a17c4101
CC
421 if [ $res -ne 0 ]; then
422 echo >&2 "bisect run failed:"
155fc795 423 echo >&2 "'bisect_state $state' exited with error code $res"
a17c4101
CC
424 exit $res
425 fi
426
427 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
428 echo "bisect run success"
429 exit 0;
430 fi
431
432 done
433}
434
435
8cc6a083
LT
436case "$#" in
4370)
438 usage ;;
439*)
440 cmd="$1"
441 shift
442 case "$cmd" in
443 start)
444 bisect_start "$@" ;;
155fc795
CC
445 bad|good|skip)
446 bisect_state "$cmd" "$@" ;;
8cc6a083
LT
447 next)
448 # Not sure we want "next" at the UI level anymore.
449 bisect_next "$@" ;;
cc9f24d0
JH
450 visualize)
451 bisect_visualize "$@" ;;
8cc6a083
LT
452 reset)
453 bisect_reset "$@" ;;
e204de28
JH
454 replay)
455 bisect_replay "$@" ;;
456 log)
457 cat "$GIT_DIR/BISECT_LOG" ;;
a17c4101
CC
458 run)
459 bisect_run "$@" ;;
8cc6a083
LT
460 *)
461 usage ;;
462 esac
463esac